#include <iostream>
#include <chrono>
#include <cmath>
#include <fstream>
#include <numeric>
#include <sstream>
#include <string>
#include <cstring>
#include <vector>
// #include <omp.h>
// #include <arm_neon.h>
#include "Utils_eigne.h"
#include "/usr/local/mdc_sdk_llvm/dp_gea/mdc_cross_compiler/sysroot/usr/include/opencv4/opencv2/imgcodecs.hpp"
#include "/usr/local/mdc_sdk_llvm/dp_gea/mdc_cross_compiler/sysroot/usr/include/opencv4/opencv2/imgproc.hpp"
// ========================= Defines ================== //

Vec3D<int> imageVector;

// ========================= Functions ================== //
Vec3D<float> convert_cv_to_vector(cv::Mat image){

    Vec3D<float> imageVector;

    for (int i = 0; i < image.rows; ++i) {
        std::vector<std::vector<float>> rowVector;

        for (int j = 0; j < image.cols; ++j) {
            cv::Vec3b pixel = image.at<cv::Vec3b>(i, j);
            std::vector<float> pixelVector = {static_cast<float>(pixel[0]),
                                            static_cast<float>(pixel[1]),
                                            static_cast<float>(pixel[2])};
            rowVector.push_back(pixelVector);
        }

        imageVector.push_back(rowVector);
    }


    return imageVector;
}
int height   = 900;
int width    = 1600;
int channels = 3;
cv::Vec<float, 3> temp_conversion;
// Convert to cv::Mat
cv::Mat imageMat(height, width, CV_32FC(channels));
const int num_threads = 3; 
cv::Mat convert_vector_to_cv(std::vector<std::vector<std::vector<float>>> imageVector){

    // // // Dimensions
    // int height   = imageVector.size();
    // int width    = imageVector[0].size();
    // int channels = imageVector[0][0].size();


    for (int y = 0; y < height; ++y) {

         for (int x = 0; x < width; ++x) {
                 temp_conversion = cv::Vec<float,3>(imageVector[y][x][0], imageVector[y][x][1], imageVector[y][x][2]);
                 imageMat.at<cv::Vec<float, 3>>(y, x) = temp_conversion;
                // memcpy(imageMat.ptr<float>(y, x), imageVector[y][x].data(), sizeof(float) * channels);
         }
     }

    return imageMat;

}


double interpolate(int p1, int p2, int p3, int p4, double x_diff, double y_diff) {
    return p1 * (1 - x_diff) * (1 - y_diff) +
           p2 * x_diff * (1 - y_diff) +
           p3 * y_diff * (1 - x_diff) +
           p4 * x_diff * y_diff;
}

std::vector<uchar>* matToVectorPointer(const cv::Mat& mat) {
    if (mat.empty()) {
        return nullptr; // Return nullptr if the input matrix is empty
    }

    // Calculate the total number of elements in the cv::Mat
    int totalSize = mat.total() * mat.elemSize();

    // Create a new vector with the same data as the cv::Mat
    std::vector<uchar>* vec = new std::vector<uchar>(mat.data, mat.data + totalSize);

    return vec;
}


// Convert vector pointer (BGR) to cv::Mat
cv::Mat vectorPointerToMat(const std::vector<uchar>* vec, int rows, int cols) {
    // Create a cv::Mat with the specified rows and cols
    cv::Mat temp(rows, cols, CV_8UC3);
    // Copy the data from the vector to the cv::Mat
    memcpy(temp.data, vec->data(), rows * cols * 3 * sizeof(unsigned char));
    return temp;
}
// std::vector<std::vector<std::vector<float>>> convert_cv_to_vector(cv::Mat image, int &newWidth, int &newHeight)
// {
//     /*
//     1.Scale image size proportionally
//     2.normalize image
//     */

//     std::vector<std::vector<std::vector<int>>> imageVector;

//     int height = image.rows;
//     int width = image.cols;
//     int channels = 3;

//     // Set mean, standard parameter size
//     std::vector<float> mean = {123.6750, 116.2800, 103.5300};
//     std::vector<float> standard = {58.3950, 57.1200, 57.3750};

//     std::vector<float> scale = {1333.0, 800.0};
//     float scale_factor = std::min(scale[0] / std::max(height, width), scale[1] / std::min(height, width));
//     newWidth = static_cast<int>(width * scale_factor + 0.5);
//     newHeight = static_cast<int>(height * scale_factor + 0.5);
//     // INFO_LOG("scale_factor%f",scale_factor);

//     std::vector<std::vector<std::vector<float>>> resizedImage(channels,
//                                                               std::vector<std::vector<float>>(newHeight, std::vector<float>(newWidth)));

//     double x_ratio = static_cast<double>(width) / newWidth;
//     double y_ratio = static_cast<double>(height) / newHeight;
//     // INFO_LOG("x_ratio:%f,x_ratio:%f",x_ratio,y_ratio);

//     for (int i = 0; i < newHeight; ++i)
//     {
//         for (int j = 0; j < newWidth; ++j)
//         {
//             double x = (j + 0.5) * x_ratio - 0.5;
//             double y = (i + 0.5) * y_ratio - 0.5;

//             int x1 = static_cast<int>(floor(x));
//             int y1 = static_cast<int>(floor(y));
//             int x2 = std::min(x1 + 1, width - 1);  // Bound checking for x2
//             int y2 = std::min(y1 + 1, height - 1); // Bound checking for y2

//             double x_diff = x - x1;
//             double y_diff = y - y1;

//             // for (int c = 0; c < channels; ++c)
//             for (int c = 0; c < channels; ++c)
//             {
//                 int k = channels - 1 - c;
//                 int p1 = static_cast<int>(image.at<cv::Vec3b>(std::max(0, y1), std::max(0, x1))[k]);
//                 int p2 = static_cast<int>(image.at<cv::Vec3b>(std::max(0, y1), std::max(0, x2))[k]);
//                 int p3 = static_cast<int>(image.at<cv::Vec3b>(std::max(0, y2), std::max(0, x1))[k]);
//                 int p4 = static_cast<int>(image.at<cv::Vec3b>(std::max(0, y2), std::max(0, x2))[k]);

//                 float temp = static_cast<float>(interpolate(
//                     p1, p2, p3, p4,
//                     x_diff, y_diff));
//                 resizedImage[c][i][j] = (temp - mean[c]) / standard[c];
//             }
//         }
//     }
//     return resizedImage;
// }


cv::Mat convert_vector_to_cv_after_padding(std::vector<std::vector<std::vector<float>>> imageVector){

    // Dimensions
    int height   = imageVector[0][0].size();
    int width    = imageVector[0].size();
    int channels = imageVector.size();

    // Convert to cv::Mat
    cv::Mat imageMat(height, width, CV_32FC(channels));


    for (int y = 0; y < height; ++y) {
         for (int x = 0; x < width; ++x) {
                 cv::Vec<float, 3> temp = cv::Vec<float,3>(imageVector[0][x][y], imageVector[1][x][y], imageVector[2][x][y]);
                 imageMat.at<cv::Vec<float, 3>>(y, x) = temp;
         }
     }


    return imageMat;
}



Vec3D<int> resize_Image(
    const Vec3D<int>& image,
    int newWidth,
    int newHeight
) {
    int height = image.size();
    int width = image[0].size();
    int channels = image[0][0].size();

    Vec3D<int> resizedImage(newHeight, std::vector<std::vector<int>>(newWidth, std::vector<int>(channels)));

    double x_ratio = static_cast<double>(width) / newWidth;
    double y_ratio = static_cast<double>(height) / newHeight;

    for (int i = 0; i < newHeight; ++i) {
        for (int j = 0; j < newWidth; ++j) {
            double x = (j + 0.5) * x_ratio - 0.5;
            double y = (i + 0.5) * y_ratio - 0.5;

            int x1 = static_cast<int>(floor(x));
            int y1 = static_cast<int>(floor(y));
            int x2 = std::min(x1 + 1, width - 1); // Bound checking for x2
            int y2 = std::min(y1 + 1, height - 1); // Bound checking for y2

            double x_diff = x - x1;
            double y_diff = y - y1;

            for (int c = 0; c < channels; ++c) {
                // Bilinear interpolation
                int p1 = image[std::max(0, y1)][std::max(0, x1)][c];
                int p2 = image[std::max(0, y1)][std::max(0, x2)][c];
                int p3 = image[std::max(0, y2)][std::max(0, x1)][c];
                int p4 = image[std::max(0, y2)][std::max(0, x2)][c];

                resizedImage[i][j][c] = static_cast<int>(interpolate(
                    p1, p2, p3, p4,
                    x_diff, y_diff
                ));
            }
        }
    }

    return resizedImage;
}

Vec3D<float> normalize_image (
    Vec3D<int> img,
    std::vector<float> mean,
    std::vector<float> std
    ){
//std::cout << img.size() << " " << img[0].size() <<std::endl;
    Vec3D<float> normalize_img((img.size()),
        Vec2D<float>(img[0].size(), std::vector<float>(3)));

    
    for(size_t i=0; i <img.size(); i++)
        for(size_t j=0; j < img[0].size(); j++)
            for(size_t k=0; k < 3; k++)
                normalize_img[i][j][k] = (img[i][j][k] - mean[k]) / std[k];

    return normalize_img;

    }

// Vec3D<float> normalize_image(const Vec3D<int>& img, const std::vector<float>& mean, const std::vector<float>& std) {
//     // Validate input dimensions (assuming consistent channel count across images)
//     if (img.size() != mean.size() || img.size() != std.size()) {
//         throw std::invalid_argument("Input image, mean, and standard deviation vectors must have the same size (number of channels).");
//     }

//     // Create a normalized image of the same size and type as the input image
//     Vec3D<float> normalized_img(img.size(), Vec2D<float>(img[0].size(), std::vector<float>(3, 0.0f))); // Pre-fill with zeros for efficiency

//     // Vectorization using SIMD instructions (adjust based on hardware and compiler support)
//     // #ifdef _MSC_VER  // Microsoft Visual C++
//     //     #include <intrin.h>
//     //     #define SIMD_ALIGNMENT 16  // Assuming 16-byte alignment for AVX intrinsics
//     // #elif defined(__GNUC__)  // GCC and Clang
//     //     #include <x86intrin.h>
//     //     #define SIMD_ALIGNMENT 32  // Assuming 32-byte alignment for SSE intrinsics
//     // #endif

//     size_t channels = img.size();
//     for (size_t y = 0; y < img[0].size(); y++) {
//         const int* img_row = &img[y].data();
//         float* norm_row = normalized_img[y].data();

//         #ifdef _MSC_VER
//         for (size_t x = 0; x < img[y].size() * channels; x += 8) {  // Process 8 elements at a time (adjust based on vector width)
//             __m256 img_vec = _mm256_loadu_ps((const float*)(img_row + x));
//             __m256 mean_vec = _mm256_loadu_ps(mean.data());
//             __m256 std_vec = _mm256_loadu_ps(std.data());

//             __m256 norm_vec = _mm256_div_ps(_mm256_sub_ps(img_vec, mean_vec), std_vec);

//             _mm256_storeu_ps(norm_row + x, norm_vec);
//         }
//         #elif defined(__GNUC__)
//         for (size_t x = 0; x < img[y].size() * channels; x += 4) {  // Process 4 elements at a time (adjust based on vector width)
//             __m128 img_vec = _mm_loadu_ps((const float*)(img_row + x));
//             __m128 mean_vec = _mm_loadu_ps(mean.data());
//             __m128 std_vec = _mm_loadu_ps(std.data());

//             __m128 norm_vec = _mm_div_ps(_mm_sub_ps(img_vec, mean_vec), std_vec);

//             _mm_storeu_ps(norm_row + x, norm_vec);
//         }
//         #else
//         // Fallback for non-supported compilers:
//         for (size_t x = 0; x < img[y].size(); x++) {
//             for (size_t c = 0; c < channels; c++) {
//                 normalized_img[y][x][c] = (float(img[y][x][c]) - mean[c]) / std[c];
//             }
//         }
//         #endif
//     }

//     return normalized_img;
// }





// Vec3D<float> pad_image_Mat (
//         cv::Mat &img,
//         float pad_size_divisor = 32){

//     Vec3D<float> img_new(img.channels(), std::vector<std::vector<float>>(img.rows, std::vector<float>(img.cols)));

//     for (int i = 0; i < img.rows; ++i) {
//         for (int j = 0; j < img.cols; ++j) {
//             cv::Vec3f pixel = img.at<cv::Vec3f>(i, j);
//             for (int k = 0; k < img.channels(); ++k) {
//                 img_new[k][i][j] = pixel[k];
//             }
//         }
//     }

//     //std::cout << img_new.size() << " "<< img_new[0].size() << " "<< img_new[0][0].size() << " " <<(float)img_new[0].size()/pad_size_divisor <<std::endl;
//     int dim  =  img_new.size();
//     std::vector<int> all_sizes = {(int)(img_new.size()),(int)(img_new[0].size()),(int)(img_new[0][0].size())};

//     std::vector<float> max_sizes = {std::ceil((float)img_new.size()/pad_size_divisor)*pad_size_divisor,
//                                     std::ceil((float)img_new[0].size()/pad_size_divisor)*pad_size_divisor,
//                                     std::ceil((float)img_new[0][0].size()/pad_size_divisor)*pad_size_divisor};

//     std::vector<_Float64> padded_sizes{(max_sizes[0] - all_sizes[0]),
//                 (max_sizes[1] - all_sizes[1]),
//                 (max_sizes[2] - all_sizes[2])};

//     padded_sizes[0] = 0;
//     auto sum_of_elems = std::accumulate(padded_sizes.begin(), padded_sizes.end(), 0);

//     if(sum_of_elems == 0)
//         return img_new;


//     if(padded_sizes[1]>0)
//     {
//         std::vector<float> temp(img_new[0][0].size(), 0);
//         for (int c=0; c<3; c++)
//             for(int w=0; w<padded_sizes[1]; w++)
//                 img_new[c].push_back(temp);
//     }
//     if(padded_sizes[2]>0)
//     {
//         for (int c=0; c<3; c++)
//             for(int w=0; w<padded_sizes[1]; w++)
//                 for(int h=0; h<padded_sizes[2]; h++)
//                     img_new[c][w].push_back(0);
//     }


//     return img_new;
// }



Vec3D<float> pad_image_Mat (
        cv::Mat img,
        float pad_size_divisor = 32){

    Vec3D<float> img_new(img.channels(), std::vector<std::vector<float>>(img.rows, std::vector<float>(img.cols)));

    for (int i = 0; i < img.rows; ++i) {
        for (int j = 0; j < img.cols; ++j) {
            cv::Vec3f pixel = img.at<cv::Vec3f>(i, j);
            for (int k = 0; k < img.channels(); ++k) {
                img_new[k][i][j] = pixel[k];
            }
        }
    }

    //std::cout << img_new.size() << " "<< img_new[0].size() << " "<< img_new[0][0].size() << " " <<(float)img_new[0].size()/pad_size_divisor <<std::endl;
    int dim  =  img_new.size();
    std::vector<int> all_sizes = {(int)(img_new.size()),(int)(img_new[0].size()),(int)(img_new[0][0].size())};

    std::vector<float> max_sizes = {std::ceil((float)img_new.size()/pad_size_divisor)*pad_size_divisor,
                                    std::ceil((float)img_new[0].size()/pad_size_divisor)*pad_size_divisor,
                                    std::ceil((float)img_new[0][0].size()/pad_size_divisor)*pad_size_divisor};

    std::vector<_Float64> padded_sizes{(max_sizes[0] - all_sizes[0]),
                (max_sizes[1] - all_sizes[1]),
                (max_sizes[2] - all_sizes[2])};

    padded_sizes[0] = 0;
    auto sum_of_elems = std::accumulate(padded_sizes.begin(), padded_sizes.end(), 0);

    if(sum_of_elems == 0)
        return img_new;


    if(padded_sizes[1]>0)
    {
        std::vector<float> temp(img_new[0][0].size(), 0);
        for (int c=0; c<3; c++)
            for(int w=0; w<padded_sizes[1]; w++)
                img_new[c].push_back(temp);
    }
    if(padded_sizes[2]>0)
    {
        for (int c=0; c<3; c++)
            for(int w=0; w<padded_sizes[1]; w++)
                for(int h=0; h<padded_sizes[2]; h++)
                    img_new[c][w].push_back(0);
    }


    return img_new;
}







Vec3D<float> pad_image (
    Vec3D<float> img,
    float pad_size_divisor = 32){

        Vec3D<float> img_new((img[0][0].size()),
        Vec2D<float>(img.size(), std::vector<float>(img[0].size())));
        
            for (int i = 0; i < img.size(); ++i) {
        for (int j = 0; j < img[0].size(); ++j) {
            for (int k = 0; k < img[0][0].size(); ++k) {
                img_new[k][i][j] = img[i][j][k];
            }
        }
    }

    int dim  =  img_new.size();
    std::vector<int> all_sizes = {(int)(img_new.size()),(int)(img_new[0].size()),(int)(img_new[0][0].size())};

    std::vector<float> max_sizes = {std::ceil((float)img_new.size()/pad_size_divisor)*pad_size_divisor,
                                    std::ceil((float)img_new[0].size()/pad_size_divisor)*pad_size_divisor,
                                    std::ceil((float)img_new[0][0].size()/pad_size_divisor)*pad_size_divisor};

    std::vector<_Float64> padded_sizes{(max_sizes[0] - all_sizes[0]),
                                        (max_sizes[1] - all_sizes[1]),
                                        (max_sizes[2] - all_sizes[2])};

    padded_sizes[0] = 0;
    auto sum_of_elems = std::accumulate(padded_sizes.begin(), padded_sizes.end(), 0);

    if(sum_of_elems == 0)
        return img_new;


    if(padded_sizes[1]>0)
    {
        std::vector<float> temp(img_new[0][0].size(), 0);
        for (int c=0; c<3; c++)
            for(int w=0; w<padded_sizes[1]; w++)
                img_new[c].push_back(temp);
    }
    if(padded_sizes[2]>0)
    {
        for (int c=0; c<3; c++)
            for(int w=0; w<padded_sizes[1]; w++)
                for(int h=0; h<padded_sizes[2]; h++)
                img_new[c][w].push_back(0);
    }

    return img_new;
    }

    Vec3D<float> resizedImage(channels, std::vector<std::vector<float>>(height, std::vector<float>(width)));

// static constexpr float32x4_t v_one = vdupq_n_f32(1.0f);
// Vec3D<float> preprocess_func(Vec3D<float> imageVectorPtr){
Vec3D<float> preprocess_func(std::vector<uchar>* imageVectorPtr){

// cv::Mat imageMat(height, width, CV_8UC3, imageVectorPtr->data());
cv::Mat imageMat = vectorPointerToMat(imageVectorPtr, 900, 1600);
// std::cout << "image mat inside the preprocess: " << std::endl << imageMat << std::endl;


cv::Mat floatImage;
imageMat.convertTo(floatImage, CV_32FC3);
// Split the image into separate channels
std::vector<cv::Mat> channels;
cv::split(floatImage, channels);

// Normalize each channel independently
for (int i = 0; i < floatImage.channels(); ++i) {
    channels[i].convertTo(channels[i], CV_32FC1);
    channels[i] = (channels[i]- mean[i]) / std_dev[i];
}

// Merge the channels back into the original image
cv::merge(channels, floatImage);

return pad_image_Mat(floatImage);
}